searchNodes=[{"doc":"This is the base Nerves System configuration for the BeagleBone Black , BeagleBone Green , BeagleBone Green Wireless , and PocketBeagle . &lt;sup&gt;[Image credit](#fritzing)&lt;/sup&gt; Feature Description CPU 1 GHz ARM Cortex-A8 Memory 512 MB DRAM Storage 4 GB eMMC Flash and MicroSD Linux kernel 5.10 w/ BBB patches IEx terminal UART ttyS0 GPIO, I2C, SPI Yes - Elixir Circuits ADC Yes PWM Yes, but no Elixir support UART ttyS0 + more via device tree overlay Camera None Ethernet Yes WiFi Beaglebone Green Wireless (wl18xx driver). Other requires USB WiFi dongle/driver HW Watchdog AM335x watchdog enabled on boot. Be sure to enable heart in your vm.args or the device will reboot","ref":"readme.html","title":"Generic BeagleBone Support","type":"extras"},{"doc":"The most common way of using this Nerves System is create a project with mix nerves.new and to export MIX_TARGET=bbb . See the Getting started guide for more information. If you need custom modifications to this system for your device, clone this repository and update as described in Making custom systems .","ref":"readme.html#using","title":"Generic BeagleBone Support - Using","type":"extras"},{"doc":"If your BeagleBone has eMMC (the PocketBeagle doesn't), it will be configured to try the eMMC first when looking for software on boot. If you haven't reprogrammed it, it will boot to Debian even if a MicroSD card is inserted with good software. To boot from the MicroSD card, hold down the USER button and apply power. When starting with Nerves, you will find that booting from a MicroSD card is convenient since you can easily recover from broken software images. Holding down the USER button will get old. To force the BeagleBone to boot from the MicroSD card, simply corrupt the image on the eMMC memory. Don't worry, the BeagleBone website has instructions for restoring Debian. From Debian: debian@beaglebone:~$ sudo dd if=/dev/zero of=/dev/mmcblk0 bs=1M count=100 100+0 records in 100+0 records out 104857600 bytes (105 MB) copied, 5.72098 s, 18.3 MB/s debian@beaglebone:~$ sudo reboot When it reboots, it will boot from the MicroSD slot. If a MicroSD card hasn't been inserted or if there are errors reading it, you will see the letter C printed repeatedly on the console port.","ref":"readme.html#preparing-your-beaglebone","title":"Generic BeagleBone Support - Preparing your BeagleBone","type":"extras"},{"doc":"The console is configured to output to the 6 pin header on the BeagleBone that's labeled J1. A 3.3V FTDI cable is needed to access the output. The HDMI output has been disabled via device tree to free up pins on the GPIO header. If you would like console access via HDMI, you will need to enable HDMI support in the Linux kernel, remove the HDMI disable argument in the uboot script providing kernel arguments, and change erlinit.conf to output to tty1 .","ref":"readme.html#console-access","title":"Generic BeagleBone Support - Console access","type":"extras"},{"doc":"This system supports storing provisioning information in a small key-value store outside of any filesystem. Provisioning is an optional step and reasonable defaults are provided if this is missing. Provisioning information can be queried using the Nerves.Runtime KV store's Nerves.Runtime.KV.get/1 function. Keys used by this system are: Key Example Value Description nerves_serial_number &quot;12345678&quot; By default, this string is used to create unique hostnames and Erlang node names. If unset, it defaults to part of the BBB's serial number. The normal procedure would be to set these keys once in manufacturing or before deployment and then leave them alone. For example, to provision a serial number on a running device, run the following and reboot: iex&gt; cmd ( &quot;fw_setenv nerves_serial_number 12345678&quot; ) This system supports setting the serial number offline. To do this, set the NERVES_SERIAL_NUMBER environment variable when burning the firmware. If you're programming MicroSD cards using fwup , the commandline is: sudo NERVES_SERIAL_NUMBER=12345678 fwup path_to_firmware.fw Serial numbers are stored on the MicroSD card so if the MicroSD card is replaced, the serial number will need to be reprogrammed. The numbers are stored in a U-boot environment block. This is a special region that is separate from the application partition so reformatting the application partition will not lose the serial number or any other data stored in this block. Additional key value pairs can be provisioned by overriding the default provisioning.conf file location by setting the environment variable NERVES_PROVISIONING=/path/to/provisioning.conf . The default provisioning.conf will set the nerves_serial_number , if you override the location to this file, you will be responsible for setting this yourself.","ref":"readme.html#provisioning-devices","title":"Generic BeagleBone Support - Provisioning devices","type":"extras"},{"doc":"The BeagleBone Black has many options for Linux that vary by kernel version and patch set. Nerves tracks those maintained by Robert Nelson at eewiki.net . Nerves also integrates the BeagleBone Black's U-boot patches to support device tree overlays. Support mirrors the BeagleBone docs with the exception that to set U-boot environment variables, See the section below for more information.","ref":"readme.html#linux-and-u-boot-versions","title":"Generic BeagleBone Support - Linux and U-Boot versions","type":"extras"},{"doc":"Most pins on the BBB's headers are configurable via a mechanism called the device tree. The device tree is made up of device tree files and overlay files that get compiled down into one or more .dtb or .dtbo files. The files tell Linux what drivers to load and what parameters to use for things that it can't figure out by itself. There are two strategies for dealing with the device tree: Modify the device tree files for an existing board to make your own Load device tree overlay files Upstream BBB encourages the second option since it can be easier. The tradeoff is that if anything goes wrong or your hardware doesn't match their assumptions, it's a little harder to debug. The device tree files are loaded by U-Boot. Nerves installs all of the Beagleboard overlay files to /lib/firmware and configures U-Boot to closely match upstream. This means that most of the upstream documentation on device tree is usable. The difference is that instead of using /boot/uEnv.txt to customize the overlays, you need to set the variables in the U-Boot environment block. This can be done by running cmd(&quot;fw_setenv &lt;key&gt; &lt;value&gt;&quot;) from the IEx prompt or by adding the variables to the fwup_include/provisioning.conf file. For example, at the IEx prompt: cmd ( &quot;fw_setenv uboot_overlay_addr7 /lib/firmware/BB-UART1-00A0.dtbo&quot; ) Or by updating the configuration file: uboot_setenv ( uboot - env , &quot;uboot_overlay_addr7&quot; , &quot;/lib/firmware/BB-UART1-00A0.dtbo&quot; ) See elinux.org/Beagleboard:BeagleBoneBlack_Debian for documentation on the variables. Universal I/O The BBB's Universal device tree overlay lets you configure pins at runtime. This system enables the universal overlay by default. See the enable_uboot_cape_universal setting in the default fwup_include/provisioning.conf file. See beaglebone-universal-io for documentation. You'll see references to an RCN-built kernel. RCN is the initials for Robert Nelson and we use his kernel patches. ADCs The following example shows how to read values from the 7 ADC inputs in Elixir. You will first need to load &quot;BB-ADC&quot; device tree overlay using the guide described above. iex ( nerves @nerves - 0014 . local ) &gt; ls &quot;/sys/bus/iio/devices/iio:device0&quot; buffer dev in_voltage0_raw in_voltage1_raw in_voltage2_raw in_voltage3_raw in_voltage4_raw in_voltage5_raw in_voltage6_raw name of_node power scan_elements subsystem uevent iex ( nerves @nerves - 0014 . local ) &gt; File . read ( &quot;/sys/bus/iio/devices/iio:device0/in_voltage0_raw&quot; ) { :ok , &quot;3891 \\n &quot; } iex ( nerves @nerves - 0014 . local ) &gt; File . read ( &quot;/sys/bus/iio/devices/iio:device0/in_voltage0_raw&quot; ) { :ok , &quot;3890 \\n &quot; } iex ( nerves @nerves - 0014 . local ) &gt; File . read ( &quot;/sys/bus/iio/devices/iio:device0/in_voltage0_raw&quot; ) { :ok , &quot;3891 \\n &quot; } SPI The following examples shows how to get SPI0 functional in Elixir. Load the &quot;BB-SPIDEV0&quot; device tree overlay using the guide described above. Verify that the device drivers are loaded and read spi0 transfers: iex ( nerves @nerves - 0014 . local ) &gt; ls &quot;/dev&quot; ... spidev1 . 0 spidev1 . 1 spidev2 . 0 spidev2 . 1 ... iex ( nerves @nerves - 0014 . local ) &gt; File . read &quot;/sys/bus/spi/devices/spi1.0/statistics/transfers&quot; { :ok , &quot;0&quot; } If you have included circuits_spi as a dependency, you can start it now and test a transfer: The example below should work without any additional hardware connected to the BBB. If you have SPI hardware connected to the BBB, your returned binary might be different. iex ( nerves @nerves - 0014 . local ) &gt; { :ok , ref } = Circuits.SPI . open ( &quot;spidev0.0&quot; ) { :ok , # Reference &lt; ... &gt; } iex ( nerves @nerves - 0014 . local ) &gt; Circuits.SPI . transfer ( ref , &lt;&lt; 1 , 2 , 3 , 4 &gt;&gt; ) &lt;&lt; 255 , 255 , 255 , 255 &gt;&gt; Note: If you get back all 0's, then you have likely have not configured the overlay pins correctly.","ref":"readme.html#device-tree-overlays","title":"Generic BeagleBone Support - Device tree overlays","type":"extras"},{"doc":"The PRUs are controlled via uio . Two kernel modules are needed for them to work. iex&gt; :os . cmd ( &#39;modprobe uio uio_pruss&#39; ) iex&gt; ls &quot;/sys/class/uio&quot; uio0 uio1 uio2 uio3 uio4 uio5 uio6 uio7 Check the beaglebone am335x_pru_package repository for samples on how to interface PRUs.","ref":"readme.html#prus","title":"Generic BeagleBone Support - PRUS","type":"extras"},{"doc":"The base image includes drivers and firmware for the TI WiLink8 ( wl18xx ), Ralink RT53xx ( rt2800usb driver) and RealTek RTL8712U ( r8712u driver) devices. All WiFi drivers are compiled as modules. Some drivers can be loaded automatically. If you have a Beaglebone Green or Beaglebone Black with built-in WiFi, see the next section. We are still working out which subset of all possible WiFi dongles to support in our images. At some point, we may have the option to support all dongles and selectively install modules at packaging time, but until then, these drivers and their associated firmware blobs add significantly to Nerves release images. If you are unsure what driver your WiFi dongle requires, run Raspbian and configure WiFi for your device. At a shell prompt, run lsmod to see which drivers are loaded. Running dmesg may also give a clue. When using dmesg , reinsert the USB dongle to generate new log messages if you don't see them.","ref":"readme.html#supported-usb-wifi-devices","title":"Generic BeagleBone Support - Supported USB WiFi devices","type":"extras"},{"doc":"Initial support for the BBGW's onboard wireless module is available. To try it out, run (assuming you have VintageNet in your image): :os . cmd ( &#39;modprobe wl18xx&#39; ) :os . cmd ( &#39;modprobe wlcore_sdio&#39; ) VintageNetWiFi . quick_configure ( &quot;ssid&quot; , &quot;password&quot; ) Be aware that this Nerves system does not configure the MAC address. The result is that only one BBGW may exist on the WiFi network at a time.","ref":"readme.html#beaglebone-green-wifi","title":"Generic BeagleBone Support - Beaglebone Green WiFi","type":"extras"},{"doc":"The Beaglebone boards with built-in WiFi support use the WiLink8 WL1835 module. This is a combo WiFi/Bluetooth module. Bluetooth is not well supported in Nerves. However, Nerves is built on Linux so you can enable and use bluez . Another option is to use harald which can communicate with the module using low level Bluetooth HCI commands. The WL1835 requires initialization before first use. This is done via a &quot;BTS&quot; file. The TIInit_11.8.32.bts file is included in this system under lib/firmware/ti-connectivity . The Bluetooth kernel modules know how to load it automatically. If you're using harald , you will need to load it yourself. The source of the &quot;BTS&quot; file is http://www.ti.com/tool/wl18xx-bt-sp . Image credit : This image is from the Fritzing parts library.","ref":"readme.html#bluetooth","title":"Generic BeagleBone Support - Bluetooth","type":"extras"},{"doc":"Using NervesKey on an I2C bus requires the bus speed to be lowered. This can be done using uboot overlays specific to the I2C bus that NervesKey is attached to. The device tree blob can be found in /lib/firmware . Choose one of the following: uboot_setenv(uboot-env, &quot;uboot_overlay_addr4&quot;, &quot;/lib/firmware/i2c1-clock-frequency-100khz.dtbo&quot;) uboot_setenv(uboot-env, &quot;uboot_overlay_addr5&quot;, &quot;/lib/firmware/i2c2-clock-frequency-100khz.dtbo&quot;) You can configure your project to enable these device tree overlays by copying the fwup_include/provisioning.conf file to your project, updating the file to enable the uboot overlay for your NervesKey i2c bus, and by adding the following to your Mix Application configuration: config :nerves , :firmware , provisioning : &quot;project/relative/path/to/provisioning.conf&quot;","ref":"readme.html#nerveskey","title":"Generic BeagleBone Support - NervesKey","type":"extras"},{"doc":"This project does NOT follow semantic versioning. The version increases as follows: Major version updates are breaking updates to the build infrastructure. These should be very rare. Minor version updates are made for every major Buildroot release. This may also include Erlang/OTP and Linux kernel updates. These are made four times a year shortly after the Buildroot releases. Patch version updates are made for Buildroot minor releases, Erlang/OTP releases, and Linux kernel updates. They're also made to fix bugs and add features to the build infrastructure.","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"This is a bug and security fix update. It should be a low risk upgrade. Updated dependencies nerves_system_br v1.22.5 Buildroot 2022.11.3","ref":"changelog.html#v2-17-2","title":"Changelog - v2.17.2","type":"extras"},{"doc":"This is a bug fix and Erlang version bump from 25.2 to 25.2.3. It should be a low risk upgrade. Fixes Set Erlang crash dump timer to 5 seconds, so if an Erlang crash dump does happen, it will run for at most 5 seconds. See erlinit.conf. Updated dependencies nerves_system_br v1.22.3 Buildroot 2022.11.1","ref":"changelog.html#v2-17-1","title":"Changelog - v2.17.1","type":"extras"},{"doc":"This is a Buildroot version update that appears to mostly contain bug and security fixes. It should be a low risk upgrade. Updated dependencies nerves_system_br v1.22.1 Buildroot 2022.11 GCC 12.2","ref":"changelog.html#v2-17-0","title":"Changelog - v2.17.0","type":"extras"},{"doc":"Changes Two Buildroot patch updates and an Erlang minor version update Nerves Heart v2.0 is now included. Nerves Heart connects the Erlang runtime to a hardware watchdog. v2.0 has numerous updates to improve information that you can get and also has more safeguards to avoid conditions that could cause a device to hang forever. Updated dependencies nerves_system_br v1.21.6 Erlang/OTP 25.2 Buildroot 2022.08.3 nerves_heart v2.0.2","ref":"changelog.html#v2-16-2","title":"Changelog - v2.16.2","type":"extras"},{"doc":"Changes Reduce first-time Linux kernel download by using tarball source Updated dependencies nerves_system_br v1.21.2 Erlang/OTP 25.1.2","ref":"changelog.html#v2-16-1","title":"Changelog - v2.16.1","type":"extras"},{"doc":"Changes Support aarch64 Linux builds Add libdtc to support runtime loading of device tree overlays Updated dependencies nerves_system_br v1.21.1 and also see nerves_system_br v1.21.0 Buildroot 2022.08.1 Erlang/OTP 25.1.1","ref":"changelog.html#v2-16-0","title":"Changelog - v2.16.0","type":"extras"},{"doc":"Fixes Allow kernel includes for device tree overlays (Thanks @insasec) Updated dependencies nerves_system_br v1.20.6 Erlang/OTP 25.0.4 Buildroot 2022.05.2 Also see Buildroot 2022.05.1 changes","ref":"changelog.html#v2-15-3","title":"Changelog - v2.15.3","type":"extras"},{"doc":"Updated dependencies nerves_system_br v1.20.4 Erlang/OTP 25.0.3","ref":"changelog.html#v2-15-2","title":"Changelog - v2.15.2","type":"extras"},{"doc":"This release reverts the upgrade to Linux 5.15.44. The Linux kernel is now at 5.10.120. This fixes an issue where the numbering of /dev/gpiochipN changed. All code that identified GPIOs by number broke (pretty much everything using Circuits.GPIO).","ref":"changelog.html#v2-15-1","title":"Changelog - v2.15.1","type":"extras"},{"doc":"This release updates to Buildroot 2022.05, Linux 5.15.44 (from Linux 5.10) and uses GCC 11.3 (from GCC 10.3). The Linux kernel upgrade could introduce a regression, so please verify hardware-specific functionality in your firmware. Updated dependencies nerves_system_br v1.20.3 Buildroot 2022.05 Erlang/OTP 25.0.2","ref":"changelog.html#v2-15-0","title":"Changelog - v2.15.0","type":"extras"},{"doc":"This release updates to Buildroot 2022.02.1 and OTP 25.0. While this should be an easy update for most projects, many programs have been updated. Please review the changes in the updated dependencies for details. Updated dependencies nerves_system_br v1.19.0 Buildroot 2022.02.1 . Also see Buildroot 2022.02 Erlang/OTP 25.0","ref":"changelog.html#v2-14-0","title":"Changelog - v2.14.0","type":"extras"},{"doc":"Changes Fix USB/Ethernet support on the BeagleBone Green Gateway Fix regression in v2.13.3 for loading device tree overlays Pull in upstream Linux SquashFS patch to improve file system performance Updated dependencies nerves_system_br v1.18.6 linux 5.10.100","ref":"changelog.html#v2-13-4","title":"Changelog - v2.13.4","type":"extras"},{"doc":"This is mostly a Buildroot and Erlang bug and security fix release. It should be a low risk upgrade from the previous release. Changes Update the U-Boot bootloader to the 2021.10 release and pull in latest upstream Beaglebone patch set. This adds support for the BBG Gateway. Since the bootloader isn't normally updated, you'll need to re-flash the MicroSD card to get this update. If your device already works, then there's no reason to do this. Updated dependencies nerves_system_br v1.18.5 U-Boot 2021.10","ref":"changelog.html#v2-13-3","title":"Changelog - v2.13.3","type":"extras"},{"doc":"This is a Buildroot and Erlang bug fix release that also adds support for additional AM335x-based boards. It should be a low risk upgrade from the previous release. Updated dependencies nerves_system_br v1.18.4 Linux 5.10.87 Changes Support the Beaglebone Blue (robotics-focused Beaglebone) and the AM3358 EVM Starter Kit (dual Ethernet) Adjust PRU parameters to match TI configs. If you're using the PRUs, please verify that the changes do not break your code. Reduce kernel timers from 250 Hz to 100 Hz resolution. 100 Hz is the value used by the TI source and the value used by other official Nerves systems. When deriving the board serial number, fail back to the /proc/cpuinfo contents before using the wired Ethernet MAC. Specify CPU-specific flags when compiling NIFs and ports. This fixes an issue where some optimizations could not be enabled in NIFs even though it should be possible to have them. E.g., ARM NEON support for CPUs that have it. Build the Wireguard kernel driver. This is a small device driver that enables a number of VPN-based use cases.","ref":"changelog.html#v2-13-2","title":"Changelog - v2.13.2","type":"extras"},{"doc":"Updated dependencies nerves_system_br v1.18.3 Changes Programs that use OpenMP will run now. The OpenMP shared library ( libgomp.so ) was supplied by the toolchain, but not copied.","ref":"changelog.html#v2-13-1","title":"Changelog - v2.13.1","type":"extras"},{"doc":"This release updates to Buildroot 2021.11, OTP 24.2, and Linux 5.10.64. If you have made a custom system, please review the nerves_system_br release notes . Also, the previous release used Linux 5.4, so double check your Linux configuration to make sure that the update to Linux 5.10.64 doesn't disable something unexpected. Updated dependencies nerves_system_br v1.18.2 Buildroot 2021.11 Erlang/OTP 24.2 Linux 5.10.65 with RCN's TI patches. This formerly was the Beagleboard org's patch set. This should not affect most users. GCC 10.3 Improvements Support for the dl.nerves-project.org backup site. Due to a GitHub outage in November, there was a 2 day period of failing builds since some packages could not be downloaded. We implemented the backup site to prevent this in the future. This update is in the nerves_defconfig . Use new build ORB on CircleCI. This ORB will shorten build times to fit in CircleCI's new free tier limits. Please update if building your own systems.","ref":"changelog.html#v2-13-0","title":"Changelog - v2.13.0","type":"extras"},{"doc":"Updated dependencies nerves_system_br v1.17.4 Buildroot 2021.08.2 Erlang/OTP 24.1.7 .","ref":"changelog.html#v2-12-3","title":"Changelog - v2.12.3","type":"extras"},{"doc":"Updated dependencies nerves_system_br v1.17.3 Erlang/OTP 24.1.4 .","ref":"changelog.html#v2-12-2","title":"Changelog - v2.12.2","type":"extras"},{"doc":"This is a security/bug fix patch release. It should be safe to update for everyone. Updated dependencies nerves_system_br v1.17.1 Buildroot 2021.08.1 Erlang/OTP 24.1.2 Improvements Include software versioning and licensing info (see legal-info directory in artifact)","ref":"changelog.html#v2-12-1","title":"Changelog - v2.12.1","type":"extras"},{"doc":"This release updates to Buildroot 2021.08 and OTP 24.1. If you have made a custom system off this one, please review the nerves_system_br v1.17.0 release notes. Updated dependencies nerves_system_br v1.17.0 Buildroot 2021.08 Erlang/OTP 24.1","ref":"changelog.html#v2-12-0","title":"Changelog - v2.12.0","type":"extras"},{"doc":"This release updates Erlang/OTP from 24.0.3 to 24.0.5 and Buildroot from 2021.05 to 2021.05.1. Both of these are security/bug fix updates. This is expected to be a safe upgrade from v1.16.1 for all users. Updated dependencies nerves_system_br v1.16.4 Erlang/OTP 24.0.5 Improvements Beta support for using a runtime.exs script for runtime configuration. Added a provision task to the fwup.config to enable re-provisioning a MicroSD card without changing its contents. Adds a default /etc/sysctl.conf that enables use of ICMP in Erlang. This requires nerves_runtime v0.11.5 or later to automatically load the sysctl variables. With it using :gen_udp to send/receive ICMP will &quot;just work&quot;. It also makes it easier to add other sysctl variables if needed.","ref":"changelog.html#v2-11-2","title":"Changelog - v2.11.2","type":"extras"},{"doc":"This release updates Nerves Toolchains to v1.4.3 and OTP 24.0.3. It should be safe for everyone to apply. Updated dependencies nerves_system_br v1.16.1 Erlang/OTP 24.0.3 nerves toolchains v1.4.3 Improvements bborg-overlays: bump to latest SHA (device tree updates for BBB)","ref":"changelog.html#v2-11-1","title":"Changelog - v2.11.1","type":"extras"},{"doc":"This release updates to Buildroot 2021.05 and OTP 24.0.2. If you have made a custom system off this one, please review the nerves_system_br v1.16.0 release notes. Updated dependencies nerves_system_br v1.16.0 Buildroot 2021.05 Erlang/OTP 24.0.2 Improvements This release now contains debug symbols and includes the Build-ID in the ELF headers. This makes it easier to get stack traces from C programs. As before, the Nerves tooling strips all symbols from firmware images, so this won't make programs bigger. Enable compile-time wpa_supplicant options to support WPA3, mesh networking, WPS and autoscan.","ref":"changelog.html#v2-11-0","title":"Changelog - v2.11.0","type":"extras"},{"doc":"This is a security/bug fix release that updates to Buildroot 2021.02.1 and OTP 23.3.1. It should be safe for everyone to apply. Updated dependencies nerves_system_br v1.15.1 Buildroot 2021.02 Erlang/OTP 23.3.1","ref":"changelog.html#v2-10-1","title":"Changelog - v2.10.1","type":"extras"},{"doc":"This release updates to Buildroot 2021.02 and OTP 23.2.7. If you have made a custom system off this one, please review the nerves_system_br v1.15.0 release notes. The Nerves toolchain has also been updated to v1.4.2. This brings in Linux 4.14 headers to enable use of cdev and eBPF. This won't affect most users. Updated dependencies nerves_system_br v1.15.0 Buildroot 2021.02 Erlang/OTP 23.2.7 nerves toolchains v1.4.2","ref":"changelog.html#v2-10-0","title":"Changelog - v2.10.0","type":"extras"},{"doc":"This release updates to Buildroot 2020.11.2, GCC 10.2 and OTP 23.2.4. When migrating custom systems based, please be aware of the following important changes: There's a new getrandom syscall that is made early in BEAM startup. This has the potential to block the BEAM before Nerves can start rngd to provide entropy. We have not seen this issue here, but have updated erlinit.config for the time being as a precaution. The GCC 10.2.0 toolchain has a different name that calls out &quot;nerves&quot; as the vendor and the naming is now more consistent with other toolchain providers. Experimental support for tooling that requires more information about the target has been added. The initial support focuses on zigler. Updated dependencies nerves_system_br: bump to v1.14.4 Buildroot 2020.11.2 Erlang/OTP 23.2.4 Nerves toolchains 1.4.1","ref":"changelog.html#v2-9-0","title":"Changelog - v2.9.0","type":"extras"},{"doc":"This is a bug fix release with no major changes. Updated dependencies nerves_system_br: bump to v1.13.7 Erlang/OTP 23.1.5","ref":"changelog.html#v2-8-3","title":"Changelog - v2.8.3","type":"extras"},{"doc":"This release includes a patch release update to Buildroot 2020.08.2 . Updated dependencies nerves_system_br: bump to v1.13.5 erlinit 1.9.0","ref":"changelog.html#v2-8-2","title":"Changelog - v2.8.2","type":"extras"},{"doc":"The main change in this release is to bump the Linux kernel to 5.4. If you have based a custom system off of this one, please inspect the linux-5.4.defconfig for changes. There were only a few changes, but if you are modifying the kernel configuration, please review first. Updated dependencies nerves_system_br: bump to v1.13.4 Erlang/OTP 23.1.4 boardid 1.10.0 Improvements Enabled reproducible builds in Buildroot to remove some timestamp and build path differences in firmware images. This helps delta firmware updates.","ref":"changelog.html#v2-8-1","title":"Changelog - v2.8.1","type":"extras"},{"doc":"This release updates to Buildroot 2020.08 and OTP 23.1.1. Updated dependencies nerves_system_br: bump to v1.13.2 Erlang/OTP 23.1.1 erlinit 1.8.0 nerves 1.7.0 New features Added support for updating the root filesystem using firmware patches. See the firmware patch docs for more information.","ref":"changelog.html#v2-8-0","title":"Changelog - v2.8.0","type":"extras"},{"doc":"This release updates to Buildroot 2020.05.1 and OTP 23.0.3 which are both bug fix releases. Updated dependencies nerves_system_br: bump to v1.12.4 Erlang/OTP 23.0.3 nerves_heart v0.3.0 New features The /data directory now exists for storing application-specific data. It is currently a symlink to /root . Using /data will eventually be encouraged over /root even though currently there is no advantage. This change makes it possible to start migrating paths in applications and libraries. Fixes Fixed old references to the -Os compiler flag. All C/C++ code will default to using -O2 now.","ref":"changelog.html#v2-7-2","title":"Changelog - v2.7.2","type":"extras"},{"doc":"Fixes Remove nerves_system_linter from hex package. This fixes mix dependency errors in projects that reference systems with different nerves_system_linter dependency specs.","ref":"changelog.html#v2-7-1","title":"Changelog - v2.7.1","type":"extras"},{"doc":"This release updates the system to use Buildroot 2020.05 and Erlang/OTP 23. Please see the respective release notes for updates and deprecations in both projects for changes that may affect your application. New features Enable WiFi mesh support in the 802.11 stack NervesKey support (see README.md for device tree overlay information) Updated dependencies nerves_system_br v1.12.0 Erlang/OTP 23.0.2 Linux 4.19.120 with Beagleboard kernel patches","ref":"changelog.html#v2-7-0","title":"Changelog - v2.7.0","type":"extras"},{"doc":"Updated dependencies nerves_system_br v1.11.4 Erlang 22.3.4.1 fwup 1.7.0","ref":"changelog.html#v2-6-2","title":"Changelog - v2.6.2","type":"extras"},{"doc":"Updated dependencies nerves_system_br v1.11.2 Erlang 22.3.1 erlinit 1.7.0 - tty initialization support fwup 1.6.0 - xdelta3/VCDIFF patch support Enable unixodbc so that Erlang's odbc application can be used in projects","ref":"changelog.html#v2-6-1","title":"Changelog - v2.6.1","type":"extras"},{"doc":"This release updates Buildroot to 2020.02 and upgrades gcc from 8.3 to 9.2. While this is a minor version bump due to the Buildroot release update, barring advanced usage of Nerves, this is a straightforward update from v2.5.2. Updated dependencies nerves_system_br v1.11.0 linux 4.19.103 with Beagleboard kernel patches(bone40) Erlang 22.2.8","ref":"changelog.html#v2-6-0","title":"Changelog - v2.6.0","type":"extras"},{"doc":"Fixes This fixes a regression on OSX where the USB gadget Ethernet would incorrectly try to go into RNDIS mode and not work. Gadget Ethernet works with this fix on Linux and OSX. It also works on Windows with a driver installed. See the README.md for details. The USB driver uses PIO mode again. It had mistakenly been switched to DMA mode. DMA mode works for a lot of USB devices, but not all and it's not what Debian does. See PR 138 for more information. Updated dependencies nerves_system_br v1.10.2 Erlang 22.2.4","ref":"changelog.html#v2-5-2","title":"Changelog - v2.5.2","type":"extras"},{"doc":"This release changes the behavior of the gadget port. The gadget driver has been changed to use g_ether. This provides a more stable network connection at the expense of the virtual serial port. Enhancements Set expand=true on the application data partition. This will only take effect for users running the complete task, fwup will not expand application data partitions that exist during upgrade tasks. linux: swap the cdc composite gadget for g_ether Updated dependencies nerves_system_br v1.10.1 Erlang 22.2.3","ref":"changelog.html#v2-5-1","title":"Changelog - v2.5.1","type":"extras"},{"doc":"This release updates Buildroot to 2019.11 with security and bug fix updates across Linux packages. Enables dnsd, udhcpd and ifconfig in the default Busybox configuration to support vintage_net and vintage_net_wizard . See the nerves_system_br notes for details. Updated dependencies nerves_system_br v1.10.0 Erlang 22.1.8 Linux 4.19.72 with the Beagleboard Debian kernel patches","ref":"changelog.html#v2-5-0","title":"Changelog - v2.5.0","type":"extras"},{"doc":"This release updates Buildroot to 2019.08.2 with security and bug fix updates across Linux packages. See the nerves_system_br notes for details. Erlang/OTP is now at 22.1.7. This release also enables the pinmux helper for changing the pin settings on the PocketBeagle and other boards. For example: iex&gt; cat &quot;/sys/devices/platform/ocp/ocp:P2_30_pinmux/state&quot; default iex&gt; File.write(&quot;/sys/devices/platform/ocp/ocp:P2_30_pinmux/state&quot;, &quot;spi_cs&quot;) :ok For the PocketBeagle, see https://github.com/beagleboard/linux/blob/4.19/arch/arm/boot/dts/am335x-pocketbeagle.dts#L1186 Updated dependencies nerves_system_br v1.9.5","ref":"changelog.html#v2-4-2","title":"Changelog - v2.4.2","type":"extras"},{"doc":"This release pulls in security and bug fix updates from nerves_system_br . Erlang/OTP is now at 22.1.1. Updated dependencies nerves_system_br v1.9.4 bborg-overlays - update to latest to pull in device tree overlay fixes and additions from upstream","ref":"changelog.html#v2-4-1","title":"Changelog - v2.4.1","type":"extras"},{"doc":"This release updates Buildroot to 2019.08 with security and bug fix updates across Linux packages. See the nerves_system_br notes for details. Updated dependencies nerves_system_br v1.9.2 Enhancements Support a variety of USB-&gt;UART adapters so more devices work out-of-the-box","ref":"changelog.html#v2-4-0","title":"Changelog - v2.4.0","type":"extras"},{"doc":"This release fixes an issue where the MAC address for the wired Ethernet port on many BeagleBone-based boards was not being set. Unfortunately, the fix is with the U-Boot bootloader configuration and this is not updated when applying updates over-the-air. Fresh firmware installs will apply the fix, so if you're burning MicroSD cards, you're fine. It is possible to fix the wired Ethernet MAC address issue in the field if necessary. Please post to our support channels if you need to do this and are not sure. Updated dependencies nerves_system_br v1.8.5 Linux 4.19.50","ref":"changelog.html#v2-3-2","title":"Changelog - v2.3.2","type":"extras"},{"doc":"Enhancements Enable source-based routing in the Linux kernel to support vintage_net Enable pstore, an in-memory buffer that can capture logs, kernel oops and other information when unexpected reboots. The buffer can be recovered on the next boot where it can be inspected. Updated dependencies nerves_system_br v1.8.4","ref":"changelog.html#v2-3-1","title":"Changelog - v2.3.1","type":"extras"},{"doc":"This release This release updates Erlang to OTP 22 and gcc from version 7.3.0 to 8.3.0. See the nerves_system_br and toolchain release notes for more information. Enhancements Enable source-based routing in the Linux kernel to support vintage_net Updated dependencies Erlang 22.0.4 nerves_system_br v1.8.2 nerves_toolchain_arm_unknown_linux_gnueabihf v1.2.0","ref":"changelog.html#v2-3-0","title":"Changelog - v2.3.0","type":"extras"},{"doc":"Bux fixes Add TAR option --no-same-owner to fix errors when untarring artifacts as the root user. Updated dependencies nerves_system_br v1.7.2","ref":"changelog.html#v2-2-2","title":"Changelog - v2.2.2","type":"extras"},{"doc":"Bug fixes Re-enabled Ralink rt2800usb WiFi driver. Improvements Bump C compiler options to -O2 from -Os . This provides a small, but measurable performance improvement (500ms at boot in a trivial project tested on nerves_system_rpi0 ). Added r8712u.ko WiFi driver. Updated dependencies nerves_system_br v1.7.1","ref":"changelog.html#v2-2-1","title":"Changelog - v2.2.1","type":"extras"},{"doc":"Updated dependencies nerves_system_br v1.7.0 Erlang 21.2.7 Linux 4.19.26 with the Beagleboard Debian kernel patches","ref":"changelog.html#v2-2-0","title":"Changelog - v2.2.0","type":"extras"},{"doc":"Updated dependencies nerves_system_br v1.6.8 Erlang 21.2.6","ref":"changelog.html#v2-1-3","title":"Changelog - v2.1.3","type":"extras"},{"doc":"Updated dependencies nerves_system_br v1.6.6 Erlang 21.2.4 boardid 1.5.3","ref":"changelog.html#v2-1-2","title":"Changelog - v2.1.2","type":"extras"},{"doc":"Updated dependencies nerves_system_br v1.6.5 Erlang 21.2.2 boardid 1.5.2 erlinit 1.4.9 OpenSSL 1.1.1a Linux 4.19.10 with the Beagleboard Debian kernel patches Enhancements Moved boardid config from inside erlinit.config to /etc/boardid.config","ref":"changelog.html#v2-1-1","title":"Changelog - v2.1.1","type":"extras"},{"doc":"This pulls in a pending patch in Buildroot to update the version of OpenSSL from 1.0.2 to 1.1.0h. This fixes what appears to be issues with Erlang using OpenSSL engines. It also enables Erlang crypto algorithms such as ed25519 that have been added in recent Erlang releases. Updated dependencies nerves_system_br v1.6.1 Erlang 21.2 Added dependencies wpa_passphrase libp11 0.4.9","ref":"changelog.html#v2-1-0","title":"Changelog - v2.1.0","type":"extras"},{"doc":"Enhancements Enable AM335X-PRU-UIO-00A0 device tree overlay for PRU support. See the README.md for more information. Updated dependencies nerves_system_br v1.5.3","ref":"changelog.html#v2-0-0","title":"Changelog - v2.0.0","type":"extras"},{"doc":"This is a backwards incompatible update to nerves_system_bbb . Over-the-air updates to existing devices will not work. If you're a production user of nerves_system_bbb , please consider supporting efforts to maintain a v1.4.0 branch. The v2.0.0 support adds the following: Device tree overlays are applied by U-Boot now. Support in Nerves is nearly identical to Beagleboard.org's Debian distribution. This fixes significant issues in v1.4.0 and before ever since upstream moved from loading device tree overlays in Linux to U-Boot. Support for automatic failback of bad new builds. If enabled, your Nerves application will need to mark a software update as good (for example, it can contact a server) or else the next reboot will revert. The application partition uses F2FS rather than EXT4. This noticeably improves startup time on the first boot and has some less obvious advantages from being a Flash-aware file system. The hardware watchdog is enabled at boot. Your application must enable heart now. The U-Boot environment was increased in size to 128 KB. This was required for the new device tree overlay support and unfortunately makes migrating devices from v1.4.0 not possible without significant work. Updated dependencies nerves_system_br v1.5.2 Linux 4.18.9 + The Beagleboard Debian kernel patches Erlang 21.0.9","ref":"changelog.html#v2-0-0-rc-0","title":"Changelog - v2.0.0-rc.0","type":"extras"},{"doc":"This release contains various updates to provisioning variables and data. Host requirements Building firmware using this system requires fwup to be updated on your host computer to at least v1.2.5 . The target minimum version requirement has not changed from 0.15.0 . Serial numbers Device serial numbers are now set using NERVES_SERIAL_NUMBER instead of SERIAL_NUMBER . This is to reduce ambiguity on the source of the serial by name spacing it along side other Nerves variables. The U-Boot environment key has also changed from serial_number to nerves_serial_number . The erlinit.config has been updated to provide backwards compatibility for setting the hostname from the serial number by checking for nerves_serial_number and falling back to serial_number . Custom provisioning Provisioning data is applied at the time of calling the fwup task complete . The complete task is executed when writing the firmware to the target disk. During this time, fwup will include the contents of a provisioning file located at ${NERVES_SYSTEM}/images/fwup_include/provisioning.conf . By default, this file only sets nerves_serial_number . You can add additional provisioning data by overriding the location of this file to include your own by setting the environment variable NERVES_PROVISIONING . If you override this variable you will be responsible for also setting nerves_serial_number . Updated dependencies nerves_system_br v1.4.5","ref":"changelog.html#v1-4-0","title":"Changelog - v1.4.0","type":"extras"},{"doc":"This release upgrades gcc from version 6.3.0 to 7.3.0. See the toolchain release notes for more information. Switch to using busybox.fragment for easier maintainance. Updated dependencies nerves_system_br v1.4.1 nerves_toolchain_arm_unknown_linux_gnueabihf v1.1.0","ref":"changelog.html#v1-3-0","title":"Changelog - v1.3.0","type":"extras"},{"doc":"Updated dependencies nerves_system_br v1.3.2","ref":"changelog.html#v1-2-1","title":"Changelog - v1.2.1","type":"extras"},{"doc":"This release updates Erlang to OTP 21.0 Updated dependencies nerves_system_br v1.3.0","ref":"changelog.html#v1-2-0","title":"Changelog - v1.2.0","type":"extras"},{"doc":"This release fixes some issues and adds firmware UUID support. This support can be used to unambiguously know what's running on a device. Updated dependencies nerves_system_br v1.2.2 Bug fixes Empty serial numbers stored in the U-Boot environment would be used instead of reverting to devices IDs built into the CPU or board. It wasn't possible to enable QtWebEngine (needed for kiosk apps)","ref":"changelog.html#v1-1-1","title":"Changelog - v1.1.1","type":"extras"},{"doc":"This release adds official support for provisioning serial numbers to devices. Other information can be provisioned in a similar manner. See the README.md for details. Buildroot was also updated to 2018.05. Be sure to review the nerves_system_br link for the changes in the embedded Linux components. Updated dependencies nerves_system_br v1.2.0 New features More wpa-supplicant features were enabled to support more WiFi use-cases","ref":"changelog.html#v1-1-0","title":"Changelog - v1.1.0","type":"extras"},{"doc":"This release is nearly identical to rc.1 except with the deps bump to 1.0 and documentation/comment updates. Updated dependencies nerves_system_br v1.0.0 nerves_toolchain v1.0.0 nerves v1.0.0","ref":"changelog.html#v1-0-0","title":"Changelog - v1.0.0","type":"extras"},{"doc":"This release contains updates to Erlang and heart from nerves_system_br . It also has a configuration change to the Linux kernel that enables scaling the processor frequency based on workload. This makes the process run much cooler while still allowing it to increase frequency for heavy computations. Note that the trivial .fw files are no longer created by CI scripts. If you've forked this project and are building systems using CI, make sure to update your publish scripts. Updated dependencies nerves_system_br v1.0.0-rc.2 Linux 4.4.113 w/ RCN's patches","ref":"changelog.html#v1-0-0-rc-1","title":"Changelog - v1.0.0-rc.1","type":"extras"},{"doc":"Updated dependencies nerves_system_br v1.0.0-rc.0 nerves_toolchain v1.0.0-rc.0 nerves v1.0.0-rc.0","ref":"changelog.html#v1-0-0-rc-0","title":"Changelog - v1.0.0-rc.0","type":"extras"},{"doc":"Updated dependencies nerves_system_br v0.17.0 nerves_toolchain v0.13.0 nerves v0.9.0","ref":"changelog.html#v0-20-0","title":"Changelog - v0.20.0","type":"extras"},{"doc":"Updated dependencies nerves_system_br v0.16.3 This fixes the call to otp_build so that it always uses Buildroot's version the autoconf tools.","ref":"changelog.html#v0-19-1","title":"Changelog - v0.19.1","type":"extras"},{"doc":"Updated dependencies nerves_system_br v0.16.1-2017-11 Enhancements Reboot automatically if Erlang VM exits - This is consistent with other Nerves systems. See rootfs_overlay/etc/erlinit.config if undesired. Start running nerves_system_linter to check for configuration errors. Automount the boot partition readonly at /boot Support for reverting firmware. See Reverting Firmware for more info on reverting firmware. See fwup-revert.conf for more information on how fwup handles reverting.","ref":"changelog.html#v0-19-0","title":"Changelog - v0.19.0","type":"extras"},{"doc":"Updated dependencies nerves_system_br v0.15.0 toolchain v0.12.1 u-boot 2017.09 Linux 4.4.91 w/ RCN's patches Enhancements Support for nerves 0.8. Moves nerves.exs into mix.exs Support for pocketbeagle Bug Fixes Clear out the wl18xx MAC address field This will trigger the WiLink device driver to use the MAC address that TI programmed into the module rather than 00:00:de:ad:be:ef.","ref":"changelog.html#v0-18-0","title":"Changelog - v0.18.0","type":"extras"},{"doc":"Updated dependencies nerves_system_br v0.14.1","ref":"changelog.html#v0-17-1","title":"Changelog - v0.17.1","type":"extras"},{"doc":"This release changes the default IEx prompt output from the debug UART pins to a virtual serial port on the USB OTG connector. This release also enables a virtual Ethernet interface on the same USB interface for software updates. See the nerves_init_gadget project for initialization code. Updated dependencies nerves_system_br v0.14.0 Buildroot 2017.08 fwup 0.17.0 erlinit 1.2.0 nbtty 0.3.0 Enhancements Add global patch directory This is required to pull in the e2fsprogs patch that's needed now that util-linux's uuid_generate function calls getrandom and can block indefinitely for the urandom pool to initialize Bug Fixes Use nbtty by default to fix tty hang issue","ref":"changelog.html#v0-17-0","title":"Changelog - v0.17.0","type":"extras"},{"doc":"Updated dependencies nerves_system_br v0.13.7","ref":"changelog.html#v0-16-1","title":"Changelog - v0.16.1","type":"extras"},{"doc":"This release contains an updated toolchain with Linux 4.1 Headers. You will have to clean and compile any c/c++ code in your project and dependencies. Failure to do so will result in an error when producing firmware. nerves_system_br v0.13.5 fwup 0.15.4 Nerves toolchain v0.11.0","ref":"changelog.html#v0-16-0","title":"Changelog - v0.16.0","type":"extras"},{"doc":"nerves_system_br v0.13.3 erlinit 1.1.4 New features Firmware updates verify that they're updating the right target. If the target doesn't say that it's an bbb through the firmware metadata, the update will fail. Added meta-misc and meta-vcs-identifier to the fwup.conf metadata for use by users and for the regression test framework Use String.trim instead of String.strip to silence Elixir 1.5 warnings","ref":"changelog.html#v0-15-0","title":"Changelog - v0.15.0","type":"extras"},{"doc":"nerves_system_br v0.13.2 OTP 20 erlinit 1.1.3 fwup 0.15.3","ref":"changelog.html#v0-14-0","title":"Changelog - v0.14.0","type":"extras"},{"doc":"This release is NOT backwards compatible with previous releases and will not upgrade old systems. With work, it is possible to upgrade old systems, but it is not recommended. nerves_system_br v0.12.1 erlinit 1.1.1 fwup 0.15.0 New features The application data partition is now ext4 . This greatly improves its robustness to corruption. Nerves.Runtime contains code to initialize it on first boot. Firmware images now contain metadata that can be queried at runtime (see Nerves.Runtime.KV The boot partition is managed in an A/B style to support more robust firmware updates. Bug fixes The Linux kernel is no longer compiled for SMP. All Beaglebone variants are single processor. NOTE: It is possible to support &quot;failback&quot; operation of firmware updates with the BBB. I.e. if an partition doesn't boot, the system reverts to the previous one. This is not implemented here, but this system is being made to align more with implementations that do this to make the transition easier.","ref":"changelog.html#v0-13-0","title":"Changelog - v0.13.0","type":"extras"},{"doc":"nerves_system_br v0.10.0 Buildroot 2017.02 Erlang/OTP 19.3 New features Support for BBG Wireless - the BBGW's MAC Address is not automatically set so support needs to be added. However, one BBGW on a WLAN works. Bump Linux kernel to 4.4.60","ref":"changelog.html#v0-12-0","title":"Changelog - v0.12.0","type":"extras"},{"doc":"New Features Support for Nerves 0.5.0","ref":"changelog.html#v0-11-0","title":"Changelog - v0.11.0","type":"extras"},{"doc":"New features Bump toolchain to use gcc 5.3 (previously using gcc 4.9.3) Bump Linux kernel to 4.4.43","ref":"changelog.html#v0-10-0","title":"Changelog - v0.10.0","type":"extras"},{"doc":"This version switches to using the nerves_package compiler. This will consolidate overall deps and compilers. Nerves.System.BR v0.8.1 Support for distillery Support for nerves_package compiler","ref":"changelog.html#v0-9-0","title":"Changelog - v0.9.0","type":"extras"},{"doc":"When upgrading to this version, be sure to review the updates to nerves_defconfig. BR2_PACKAGE_ERLANG is no longer selected automatically and must be added. nerves_system_br v0.7.0 Package updates Buildroot 2016.08 Bug fixes Many packages were removed. These include Elixir and LFE since neither are actually used. Both are added as part of the user build step, so no functionality is lost. The most visible result is that the system images are smaller and the test .fw file boots to the Erlang prompt. Fix false positive from scrubber when checking executable formats due to C++ template instantiations. Ignores SYSV vs. GNU/Linux ABI difference.","ref":"changelog.html#v0-8-0","title":"Changelog - v0.8.0","type":"extras"},{"doc":"Package versions Nerves.System.BR v0.6.1 New features Pull in BeagleBone Green updates (new u-boot, bbg device tree)","ref":"changelog.html#v0-7-1","title":"Changelog - v0.7.1","type":"extras"},{"doc":"Nerves.System.BR v0.6.0 Package updates Erlang OTP 19 Elixir 1.3.1 fwup 0.8.0 erlinit 0.7.3 bborg-overlays (pull in I2C typo fix from upstream) Bug fixes Synchronize file system kernel configs across all platforms","ref":"changelog.html#v0-7-0","title":"Changelog - v0.7.0","type":"extras"},{"doc":"Bug Fixes Enabled bbborg-overlays for universal device tree","ref":"changelog.html#v0-6-2","title":"Changelog - v0.6.2","type":"extras"},{"doc":"Nerves.System.BR v0.5.1 Bug Fixes(nerves-env) Added include paths to CFLAGS and CXXFLAGS Pass sysroot to LDFLAGS","ref":"changelog.html#v0-6-1","title":"Changelog - v0.6.1","type":"extras"},{"doc":"Nerves.System.BR v0.5.0 New features WiFi drivers enabled by default on RPi2 and RPi3 Include wireless regulatory database in Linux kernel by default on WiFi-enabled platforms. Since kernel/rootfs are read-only and coupled together for firmware updates, the normal CRDA/udev approach isn't necessary. Upgraded the default BeagleBone Black kernel from 3.8 to 4.4.9. The standard BBB device tree overlays are included by default even though the upstream kernel patches no longer include them. Change all fwup configurations from two step upgrades to one step upgrades. If you used the base fwup.conf files to upgrade, you no longer need to finalize the upgrade. If not, there's no change.","ref":"changelog.html#v0-6-0","title":"Changelog - v0.6.0","type":"extras"},{"doc":"Nerves.System.BR v0.4.1 Bug fixes syslinux fails to boot when compiled on some gcc 5 systems Fixed regression when booting off eMMC on the BBB Package updates Erlang 18.3 Elixir 1.2.5 Enhancements Includes config-pin for controlling pin muxing. See beaglebone-universal-io","ref":"changelog.html#v0-5-0","title":"Changelog - v0.5.0","type":"extras"}]